searchData={"items":[{"type":"module","title":"Yex","doc":"Yex is wrapper library for the Yjs CRDT library.","ref":"Yex.html"},{"type":"function","title":"Yex.apply_update/2","doc":"Apply a document update on the shared document.","ref":"Yex.html#apply_update/2"},{"type":"function","title":"Examples syncs two clients by exchanging the complete document structure - Yex.apply_update/2","doc":"iex> doc1 = Yex.Doc.new()\n    iex> doc2 = Yex.Doc.new()\n    iex> {:ok, state1} = Yex.encode_state_as_update(doc1)\n    iex> {:ok, state2} = Yex.encode_state_as_update(doc2)\n    iex> Yex.apply_update(doc1, state2)\n    :ok\n    iex> Yex.apply_update(doc2, state1)\n    :ok","ref":"Yex.html#apply_update/2-examples-syncs-two-clients-by-exchanging-the-complete-document-structure"},{"type":"function","title":"Yex.apply_update_v1/2","doc":"","ref":"Yex.html#apply_update_v1/2"},{"type":"function","title":"Yex.apply_update_v2/2","doc":"","ref":"Yex.html#apply_update_v2/2"},{"type":"function","title":"Yex.encode_state_as_update/2","doc":"Encode the document state as a single update message that can be applied on the remote document. Optionally, specify the target state vector to only write the missing differences to the update message.","ref":"Yex.html#encode_state_as_update/2"},{"type":"function","title":"Examples - Yex.encode_state_as_update/2","doc":"iex> doc = Yex.Doc.new()\n    iex> {:ok, _binary} = Yex.encode_state_as_update(doc)","ref":"Yex.html#encode_state_as_update/2-examples"},{"type":"function","title":"Yex.encode_state_as_update!/2","doc":"@see encode_state_as_update/2","ref":"Yex.html#encode_state_as_update!/2"},{"type":"function","title":"Yex.encode_state_as_update_v1/2","doc":"","ref":"Yex.html#encode_state_as_update_v1/2"},{"type":"function","title":"Yex.encode_state_as_update_v2/2","doc":"","ref":"Yex.html#encode_state_as_update_v2/2"},{"type":"function","title":"Yex.encode_state_vector/1","doc":"Computes the state vector and encodes it into an Binary.\nA state vector describes the state of the local client.\nThe remote client can use this to exchange only the missing differences.","ref":"Yex.html#encode_state_vector/1"},{"type":"function","title":"Examples - Yex.encode_state_vector/1","doc":"iex> doc = Yex.Doc.new()\n    iex> {:ok, _binary} = Yex.encode_state_vector(doc)","ref":"Yex.html#encode_state_vector/1-examples"},{"type":"function","title":"Yex.encode_state_vector!/1","doc":"@see encode_state_vector/1","ref":"Yex.html#encode_state_vector!/1"},{"type":"function","title":"Yex.encode_state_vector_v1/1","doc":"","ref":"Yex.html#encode_state_vector_v1/1"},{"type":"function","title":"Yex.encode_state_vector_v2/1","doc":"","ref":"Yex.html#encode_state_vector_v2/1"},{"type":"type","title":"Yex.input_type/0","doc":"","ref":"Yex.html#t:input_type/0"},{"type":"function","title":"Yex.normalize/1","doc":"Normalize a number to a format that can be used in Yjs.","ref":"Yex.html#normalize/1"},{"type":"module","title":"Yex.Array","doc":"A shareable Array-like type that supports efficient insert/delete of elements at any position.\nThis module provides functionality for collaborative array manipulation with support for\nconcurrent modifications and automatic conflict resolution.","ref":"Yex.Array.html"},{"type":"module","title":"Features - Yex.Array","doc":"- Insert and delete elements at any position\n- Push and unshift operations for adding elements\n- Move elements between positions\n- Support for nested shared types\n- Automatic conflict resolution for concurrent modifications","ref":"Yex.Array.html#module-features"},{"type":"function","title":"Yex.Array.as_prelim/1","doc":"Converts the array to its preliminary representation.\nThis is useful when you need to serialize or transfer the array's contents.","ref":"Yex.Array.html#as_prelim/1"},{"type":"function","title":"Parameters - Yex.Array.as_prelim/1","doc":"* `array` - The array to convert","ref":"Yex.Array.html#as_prelim/1-parameters"},{"type":"function","title":"Yex.Array.delete/2","doc":"Deletes content at the specified index.\nReturns :ok on success, :error on failure.","ref":"Yex.Array.html#delete/2"},{"type":"function","title":"Parameters - Yex.Array.delete/2","doc":"* `array` - The array to modify\n  * `index` - The position to delete from (0-based)","ref":"Yex.Array.html#delete/2-parameters"},{"type":"function","title":"Yex.Array.delete_range/3","doc":"Deletes a range of contents starting at the specified index.\nReturns :ok on success, :error on failure.","ref":"Yex.Array.html#delete_range/3"},{"type":"function","title":"Parameters - Yex.Array.delete_range/3","doc":"* `array` - The array to modify\n  * `index` - The starting position to delete from (0-based)\n  * `length` - The number of elements to delete","ref":"Yex.Array.html#delete_range/3-parameters"},{"type":"function","title":"Yex.Array.fetch/2","doc":"Get content at the specified index.","ref":"Yex.Array.html#fetch/2"},{"type":"function","title":"Examples pushes a string then fetches it back - Yex.Array.fetch/2","doc":"iex> doc = Yex.Doc.new()\n    iex> array = Yex.Doc.get_array(doc, \"array\")\n    iex> Yex.Array.push(array, \"Hello\")\n    iex> Yex.Array.fetch(array, 0)\n    {:ok, \"Hello\"}","ref":"Yex.Array.html#fetch/2-examples-pushes-a-string-then-fetches-it-back"},{"type":"function","title":"Yex.Array.fetch!/2","doc":"","ref":"Yex.Array.html#fetch!/2"},{"type":"function","title":"Yex.Array.get/2","doc":"","ref":"Yex.Array.html#get/2"},{"type":"function","title":"Yex.Array.insert/3","doc":"Inserts content at the specified index.\nReturns :ok on success, :error on failure.","ref":"Yex.Array.html#insert/3"},{"type":"function","title":"Parameters - Yex.Array.insert/3","doc":"* `array` - The array to modify\n  * `index` - The position to insert at (0-based)\n  * `content` - The content to insert","ref":"Yex.Array.html#insert/3-parameters"},{"type":"function","title":"Yex.Array.insert_list/3","doc":"Insert contents at the specified index.","ref":"Yex.Array.html#insert_list/3"},{"type":"function","title":"Examples - Yex.Array.insert_list/3","doc":"iex> doc = Yex.Doc.new()\n    iex> array = Yex.Doc.get_array(doc, \"array\")\n    iex> Yex.Array.insert_list(array, 0, [1,2,3,4,5])\n    iex> Yex.Array.to_json(array)\n    [1.0, 2.0, 3.0, 4.0, 5.0]","ref":"Yex.Array.html#insert_list/3-examples"},{"type":"function","title":"Yex.Array.length/1","doc":"Returns the length of the array","ref":"Yex.Array.html#length/1"},{"type":"function","title":"Examples adds a few items to an array and returns its length - Yex.Array.length/1","doc":"iex> doc = Yex.Doc.new()\n    iex> array = Yex.Doc.get_array(doc, \"array\")\n    iex> Yex.Array.push(array, \"Hello\")\n    iex> Yex.Array.push(array, \"World\")\n    iex> Yex.Array.length(array)\n    2","ref":"Yex.Array.html#length/1-examples-adds-a-few-items-to-an-array-and-returns-its-length"},{"type":"function","title":"Yex.Array.member?/2","doc":"","ref":"Yex.Array.html#member?/2"},{"type":"function","title":"Yex.Array.move_to/3","doc":"Moves element found at `source` index into `target` index position. Both indexes refer to a current state of the document.","ref":"Yex.Array.html#move_to/3"},{"type":"function","title":"Examples pushes a string then fetches it back - Yex.Array.move_to/3","doc":"iex> doc = Yex.Doc.new()\n    iex> array = Yex.Doc.get_array(doc, \"array\")\n    iex> Yex.Array.push(array, Yex.ArrayPrelim.from([1, 2]))\n    iex> Yex.Array.push(array, Yex.ArrayPrelim.from([3, 4]))\n    iex> :ok = Yex.Array.move_to(array, 0, 2)\n    iex> Yex.Array.to_json(array)\n    [[3.0, 4.0], [1.0, 2.0]]","ref":"Yex.Array.html#move_to/3-examples-pushes-a-string-then-fetches-it-back"},{"type":"function","title":"Yex.Array.push/2","doc":"Pushes content to the end of the array.\nReturns :ok on success, :error on failure.","ref":"Yex.Array.html#push/2"},{"type":"function","title":"Parameters - Yex.Array.push/2","doc":"* `array` - The array to modify\n  * `content` - The content to append","ref":"Yex.Array.html#push/2-parameters"},{"type":"type","title":"Yex.Array.t/0","doc":"","ref":"Yex.Array.html#t:t/0"},{"type":"function","title":"Yex.Array.to_json/1","doc":"Convert to json-compatible format.","ref":"Yex.Array.html#to_json/1"},{"type":"function","title":"Examples adds a few items to an array and returns as Elixir List - Yex.Array.to_json/1","doc":"iex> doc = Yex.Doc.new()\n    iex> array = Yex.Doc.get_array(doc, \"array\")\n    iex> Yex.Array.push(array, \"Hello\")\n    iex> Yex.Array.push(array, \"World\")\n    iex> Yex.Array.to_json(array)\n    [\"Hello\", \"World\"]","ref":"Yex.Array.html#to_json/1-examples-adds-a-few-items-to-an-array-and-returns-as-elixir-list"},{"type":"function","title":"Yex.Array.to_list/1","doc":"Returns as list","ref":"Yex.Array.html#to_list/1"},{"type":"function","title":"Examples adds a few items to an array, then gets them back as Elixir List - Yex.Array.to_list/1","doc":"iex> doc = Yex.Doc.new()\n    iex> array = Yex.Doc.get_array(doc, \"array\")\n    iex> Yex.Array.push(array, \"Hello\")\n    iex> Yex.Array.push(array, \"World\")\n    iex> Yex.Array.push(array, Yex.ArrayPrelim.from([1, 2]))\n    iex> [\"Hello\", \"World\", %Yex.Array{}] = Yex.Array.to_list(array)","ref":"Yex.Array.html#to_list/1-examples-adds-a-few-items-to-an-array-then-gets-them-back-as-elixir-list"},{"type":"function","title":"Yex.Array.unshift/2","doc":"Unshifts content to the beginning of the array.\nReturns :ok on success, :error on failure.","ref":"Yex.Array.html#unshift/2"},{"type":"function","title":"Parameters - Yex.Array.unshift/2","doc":"* `array` - The array to modify\n  * `content` - The content to prepend","ref":"Yex.Array.html#unshift/2-parameters"},{"type":"module","title":"Yex.ArrayEvent","doc":"Event when Array type changes\n\n@see Yex.SharedType.observe/1\n@see Yex.SharedType.observe_deep/1","ref":"Yex.ArrayEvent.html"},{"type":"type","title":"Yex.ArrayEvent.t/0","doc":"","ref":"Yex.ArrayEvent.html#t:t/0"},{"type":"module","title":"Yex.ArrayPrelim","doc":"A preliminary array. It can be used to early initialize the contents of a Array.","ref":"Yex.ArrayPrelim.html"},{"type":"module","title":"Examples - Yex.ArrayPrelim","doc":"iex> doc = Yex.Doc.new()\n    iex> map = Yex.Doc.get_map(doc, \"map\")\n    iex> Yex.Map.set(map, \"key\", Yex.ArrayPrelim.from([\"Hello\", \"World\"]))\n    iex> {:ok, %Yex.Array{} = array} = Yex.Map.fetch(map, \"key\")\n    iex> Yex.Array.fetch(array, 1)\n    {:ok, \"World\"}","ref":"Yex.ArrayPrelim.html#module-examples"},{"type":"function","title":"Yex.ArrayPrelim.from/1","doc":"","ref":"Yex.ArrayPrelim.html#from/1"},{"type":"type","title":"Yex.ArrayPrelim.t/0","doc":"","ref":"Yex.ArrayPrelim.html#t:t/0"},{"type":"module","title":"Yex.Awareness","doc":"Awareness is an optional feature that works well together with Yjs.","ref":"Yex.Awareness.html"},{"type":"function","title":"Yex.Awareness.apply_update/3","doc":"Applies an update (incoming from remote channel or generated using [Awareness.encode_update] method) and modifies a state of a current instance.","ref":"Yex.Awareness.html#apply_update/3"},{"type":"function","title":"Examples - Yex.Awareness.apply_update/3","doc":"iex> {:ok, awareness} = Yex.Awareness.new(Yex.Doc.new())\n    iex> Yex.Awareness.clean_local_state(awareness)\n    iex> Yex.Awareness.apply_update(awareness, <<1, 210, 165, 202, 167, 8, 1, 2, 123, 125>>)\n    :ok\n    iex> Yex.Awareness.get_client_ids(awareness)\n    [2230489810]","ref":"Yex.Awareness.html#apply_update/3-examples"},{"type":"function","title":"Yex.Awareness.clean_local_state/1","doc":"","ref":"Yex.Awareness.html#clean_local_state/1"},{"type":"function","title":"Examples - Yex.Awareness.clean_local_state/1","doc":"iex> {:ok, awareness} = Yex.Awareness.new(Yex.Doc.with_options(%Yex.Doc.Options{ client_id: 100 }))\n    iex> Yex.Awareness.clean_local_state(awareness)\n    iex> Yex.Awareness.get_client_ids(awareness)\n    []","ref":"Yex.Awareness.html#clean_local_state/1-examples"},{"type":"function","title":"Yex.Awareness.client_id/1","doc":"","ref":"Yex.Awareness.html#client_id/1"},{"type":"function","title":"Yex.Awareness.demonitor_change/1","doc":"","ref":"Yex.Awareness.html#demonitor_change/1"},{"type":"function","title":"Yex.Awareness.demonitor_update/1","doc":"","ref":"Yex.Awareness.html#demonitor_update/1"},{"type":"function","title":"Yex.Awareness.encode_update/2","doc":"","ref":"Yex.Awareness.html#encode_update/2"},{"type":"function","title":"Examples - Yex.Awareness.encode_update/2","doc":"iex> {:ok, awareness} = Yex.Awareness.new(Yex.Doc.with_options(%Yex.Doc.Options{ client_id: 10 }))\n    iex> Yex.Awareness.set_local_state(awareness, %{ \"key\" => \"value\" })\n    iex> Yex.Awareness.encode_update(awareness, [10])\n    {:ok, <<1, 10, 1, 15, 123, 34, 107, 101, 121, 34, 58, 34, 118, 97, 108, 117, 101, 34, 125>>}","ref":"Yex.Awareness.html#encode_update/2-examples"},{"type":"function","title":"Yex.Awareness.get_client_ids/1","doc":"","ref":"Yex.Awareness.html#get_client_ids/1"},{"type":"function","title":"Examples - Yex.Awareness.get_client_ids/1","doc":"iex> {:ok, awareness} = Yex.Awareness.new(Yex.Doc.new())\n    iex> Yex.Awareness.apply_update(awareness, <<1, 210, 165, 202, 167, 8, 1, 2, 123, 125>>)\n    iex> Yex.Awareness.get_client_ids(awareness)\n    [2230489810]","ref":"Yex.Awareness.html#get_client_ids/1-examples"},{"type":"function","title":"Yex.Awareness.get_local_state/1","doc":"get local state of the current client","ref":"Yex.Awareness.html#get_local_state/1"},{"type":"function","title":"Examples - Yex.Awareness.get_local_state/1","doc":"iex> {:ok, awareness} = Yex.Awareness.new(Yex.Doc.with_options(%Yex.Doc.Options{ client_id: 100 }))\n    iex> Yex.Awareness.get_states(awareness)\n    %{}","ref":"Yex.Awareness.html#get_local_state/1-examples"},{"type":"function","title":"Yex.Awareness.get_states/1","doc":"","ref":"Yex.Awareness.html#get_states/1"},{"type":"function","title":"Examples - Yex.Awareness.get_states/1","doc":"iex> {:ok, awareness} = Yex.Awareness.new(Yex.Doc.with_options(%Yex.Doc.Options{ client_id: 100 }))\n    iex> Yex.Awareness.set_local_state(awareness, %{ \"key\" => \"value\" })\n    iex> Yex.Awareness.get_states(awareness)\n    %{100 => %{\"key\" => \"value\"}}","ref":"Yex.Awareness.html#get_states/1-examples"},{"type":"function","title":"Yex.Awareness.monitor_change/2","doc":"Listen to remote and local state changes. Get notified when a state is either added, updated, or removed.\n You can pass metadata as an option. This value is passed as the fourth element of the message.If omitted, it will be passed as a structure of awareness itself.","ref":"Yex.Awareness.html#monitor_change/2"},{"type":"function","title":"Examples - Yex.Awareness.monitor_change/2","doc":"iex> {:ok, awareness} = Yex.Awareness.new(Yex.Doc.with_options(%Yex.Doc.Options{ client_id: 10 }))\n    iex> Yex.Awareness.monitor_change(awareness, metadata: %{ \"key\" => \"value\" })\n    iex> Yex.Awareness.apply_update(awareness, <<1, 210, 165, 202, 167, 8, 1, 2, 123, 125>>)\n    iex> receive do {:awareness_change, %{removed: [], added: [2230489810], updated: []}, _origin,  %{ \"key\" => \"value\" } = _metadata} -> :ok end","ref":"Yex.Awareness.html#monitor_change/2-examples"},{"type":"function","title":"Yex.Awareness.monitor_update/2","doc":"Monitor to remote and local awareness changes. This event is called even when the awareness state does not change but is only updated to notify other users that this client is still online. Use this event if you want to propagate awareness state to other users.\n You can pass metadata as an option. This value is passed as the fourth element of the message.If omitted, it will be passed as a structure of awareness itself.","ref":"Yex.Awareness.html#monitor_update/2"},{"type":"function","title":"Examples - Yex.Awareness.monitor_update/2","doc":"iex> {:ok, awareness} = Yex.Awareness.new(Yex.Doc.with_options(%Yex.Doc.Options{ client_id: 10 }))\n    iex> Yex.Awareness.monitor_update(awareness)\n    iex> Yex.Awareness.set_local_state(awareness, %{ \"key\" => \"value\" })\n    iex> receive do {:awareness_update, %{removed: [], added: [10], updated: []}, _origin, _awareness} -> :ok end","ref":"Yex.Awareness.html#monitor_update/2-examples"},{"type":"function","title":"Yex.Awareness.new/1","doc":"create a new awareness instance","ref":"Yex.Awareness.html#new/1"},{"type":"function","title":"Yex.Awareness.remove_states/2","doc":"Clears out a state of a given client, effectively marking it as disconnected.","ref":"Yex.Awareness.html#remove_states/2"},{"type":"function","title":"Examples - Yex.Awareness.remove_states/2","doc":"iex> {:ok, _awareness} = Yex.Awareness.new(Yex.Doc.new())","ref":"Yex.Awareness.html#remove_states/2-examples"},{"type":"function","title":"Yex.Awareness.set_local_state/2","doc":"","ref":"Yex.Awareness.html#set_local_state/2"},{"type":"function","title":"Examples - Yex.Awareness.set_local_state/2","doc":"iex> {:ok, awareness} = Yex.Awareness.new(Yex.Doc.with_options(%Yex.Doc.Options{ client_id: 100 }))\n    iex> Yex.Awareness.set_local_state(awareness, %{ \"key\" => \"value\" })\n    iex> Yex.Awareness.get_states(awareness)\n    %{100 => %{\"key\" => \"value\"}}","ref":"Yex.Awareness.html#set_local_state/2-examples"},{"type":"type","title":"Yex.Awareness.t/0","doc":"","ref":"Yex.Awareness.html#t:t/0"},{"type":"module","title":"Yex.Doc","doc":"Document module.","ref":"Yex.Doc.html"},{"type":"module","title":"Important - Yex.Doc","doc":"It is not recommended to perform operations on a single document from multiple processes simultaneously.\n  If blocked by a transaction, the Beam scheduler threads may potentially deadlock.\n  This limitation is due to the underlying yrs and beam specifications and may be resolved in the future.","ref":"Yex.Doc.html#module-important"},{"type":"function","title":"Yex.Doc.demonitor_update/1","doc":"Stop monitoring document updates.","ref":"Yex.Doc.html#demonitor_update/1"},{"type":"function","title":"Yex.Doc.demonitor_update_v1/1","doc":"","ref":"Yex.Doc.html#demonitor_update_v1/1"},{"type":"function","title":"Yex.Doc.demonitor_update_v2/1","doc":"","ref":"Yex.Doc.html#demonitor_update_v2/1"},{"type":"function","title":"Yex.Doc.get_array/2","doc":"Get or insert the array type.","ref":"Yex.Doc.html#get_array/2"},{"type":"function","title":"Yex.Doc.get_map/2","doc":"Get or insert the map type.","ref":"Yex.Doc.html#get_map/2"},{"type":"function","title":"Yex.Doc.get_text/2","doc":"Get or insert the text type.","ref":"Yex.Doc.html#get_text/2"},{"type":"function","title":"Yex.Doc.get_xml_fragment/2","doc":"Get or insert the xml fragment type.","ref":"Yex.Doc.html#get_xml_fragment/2"},{"type":"function","title":"Yex.Doc.monitor_update/2","doc":"Monitor document updates.\n You can pass metadata as an option. This value is passed as the fourth element of the message.If omitted, it will be passed as a structure of Doc itself.","ref":"Yex.Doc.html#monitor_update/2"},{"type":"function","title":"Yex.Doc.monitor_update_v1/2","doc":"","ref":"Yex.Doc.html#monitor_update_v1/2"},{"type":"function","title":"Yex.Doc.monitor_update_v2/2","doc":"","ref":"Yex.Doc.html#monitor_update_v2/2"},{"type":"function","title":"Yex.Doc.new/1","doc":"Create a new document.\n\nworker_pid:\n   If there is a possibility of passing the created document to another process, please specify the process responsible for operating the document.\n   This process needs to handle the GenServer handle_call messages as follows:\n\n    @impl true\n    def handle_call(\n          {Yex.Doc, :run, fun},\n          _from,\n          state\n        ) do\n      {:reply, fun.(), state}\n    end","ref":"Yex.Doc.html#new/1"},{"type":"macro","title":"Yex.Doc.run_in_worker_process/2","doc":"Executes the given block in the document's worker process.\nIf the current process is already the worker process, executes directly.\nOtherwise, delegates execution to the worker process via GenServer.call.\n\nRaises if worker_pid is not set.","ref":"Yex.Doc.html#run_in_worker_process/2"},{"type":"type","title":"Yex.Doc.t/0","doc":"","ref":"Yex.Doc.html#t:t/0"},{"type":"function","title":"Yex.Doc.transaction/3","doc":"Start a transaction.","ref":"Yex.Doc.html#transaction/3"},{"type":"function","title":"Examples - Yex.Doc.transaction/3","doc":"iex> doc = Doc.new()\n    iex> text = Doc.get_text(doc, \"text\")\n    iex> Yex.Doc.monitor_update(doc)\n    iex> Doc.transaction(doc, fn ->\n    iex>   Text.insert(text, 0, \"Hello\")\n    iex>   Text.insert(text, 0, \"Hello\", %{\"bold\" => true})\n    iex> end)\n    iex> assert_receive {:update_v1, _, nil, _}\n    iex> refute_receive {:update_v1, _, nil, _} # only one update message","ref":"Yex.Doc.html#transaction/3-examples"},{"type":"function","title":"Yex.Doc.with_options/2","doc":"Create a new document with options.","ref":"Yex.Doc.html#with_options/2"},{"type":"module","title":"Yex.Doc.Options","doc":"Document options.","ref":"Yex.Doc.Options.html"},{"type":"type","title":"Yex.Doc.Options.t/0","doc":"","ref":"Yex.Doc.Options.html#t:t/0"},{"type":"behaviour","title":"Yex.DocServer","doc":"Define a `Yex.DocServer` process.\n\n`DocServer` defines a module to handle document update messages by yjs.","ref":"Yex.DocServer.html"},{"type":"behaviour","title":"Examples - Yex.DocServer","doc":"defmodule MyDocServer do\n      use Yex.DocServer\n\n      def init(_arg, state) do\n        {:ok, state}\n      end\n\n      def handle_update_v1(doc, update, origin, state) do\n        # Handle document updates from Yjs\n        # - doc: The current document state\n        # - update: Binary encoded update\n        # - origin: Source of the update\n        {:noreply, state}\n      end\n\n      def handle_awareness_change(awareness, %{removed: removed, added: added, updated: updated}, origin, state) do\n        # Handle presence/awareness changes\n        # - awareness: Current awareness state\n        # - removed/added/updated: Lists of changed client IDs\n        {:noreply, state}\n      end\n    end","ref":"Yex.DocServer.html#module-examples"},{"type":"callback","title":"Yex.DocServer.handle_awareness_change/4","doc":"Handle awareness change","ref":"Yex.DocServer.html#c:handle_awareness_change/4"},{"type":"callback","title":"Yex.DocServer.handle_call/3","doc":"Handle regular GenServer call messages.\n\nSee `c:GenServer.handle_call/3`.","ref":"Yex.DocServer.html#c:handle_call/3"},{"type":"callback","title":"Yex.DocServer.handle_cast/2","doc":"Handle regular GenServer cast messages.\n\nSee `c:GenServer.handle_cast/2`.","ref":"Yex.DocServer.html#c:handle_cast/2"},{"type":"callback","title":"Yex.DocServer.handle_info/2","doc":"Handle regular Elixir process messages.\n\nSee `c:GenServer.handle_info/2`.","ref":"Yex.DocServer.html#c:handle_info/2"},{"type":"callback","title":"Yex.DocServer.handle_update_v1/4","doc":"Handle document updates in v1 encoding format.","ref":"Yex.DocServer.html#c:handle_update_v1/4"},{"type":"callback","title":"Parameters - Yex.DocServer.handle_update_v1/4","doc":"- doc: Current document state\n- update: Binary encoded update from Yjs\n- origin: Source of the update (can be nil for local updates)\n- state: Current server state","ref":"Yex.DocServer.html#c:handle_update_v1/4-parameters"},{"type":"callback","title":"Returns - Yex.DocServer.handle_update_v1/4","doc":"- `{:noreply, state}` to continue with new state\n- `{:stop, reason, state}` to stop the server","ref":"Yex.DocServer.html#c:handle_update_v1/4-returns"},{"type":"callback","title":"Yex.DocServer.init/2","doc":"Initialize the doc process.","ref":"Yex.DocServer.html#c:init/2"},{"type":"type","title":"Yex.DocServer.option/0","doc":"","ref":"Yex.DocServer.html#t:option/0"},{"type":"type","title":"Yex.DocServer.options/0","doc":"","ref":"Yex.DocServer.html#t:options/0"},{"type":"callback","title":"Yex.DocServer.process_message_v1/3","doc":"Interprets and processes v1 encode message.","ref":"Yex.DocServer.html#c:process_message_v1/3"},{"type":"callback","title":"Yex.DocServer.start/2","doc":"Starts a `DocServer` process without linking (for use outside of a supervision tree).\n\nReturns the same success and error responses as `start_link/2`.","ref":"Yex.DocServer.html#c:start/2"},{"type":"callback","title":"Yex.DocServer.start_link/2","doc":"Starts a `DocServer` process linked to the current process.","ref":"Yex.DocServer.html#c:start_link/2"},{"type":"callback","title":"Yex.DocServer.terminate/2","doc":"Invoked when the document server process is about to exit.\n\nSee `c:GenServer.terminate/2`.","ref":"Yex.DocServer.html#c:terminate/2"},{"type":"module","title":"Yex.DocServer.State","doc":"Provides the `State` struct and functions to manage the internal state of `Yex.DocServer`.\n\nThis module allows tracking the state of `Yex.DocServer` through a structured `State` record.\nIt includes functions for assigning and updating state attributes with custom key-value pairs.","ref":"Yex.DocServer.State.html"},{"type":"function","title":"Yex.DocServer.State.assign/2","doc":"Assigns multiple key-value pairs to the `assigns` map in the state.\n\nThis function accepts a list or map of attributes to update the state in\nbulk, allowing for more comprehensive state updates at once.","ref":"Yex.DocServer.State.html#assign/2"},{"type":"function","title":"Yex.DocServer.State.assign/3","doc":"Assigns a single key-value pair to the `assigns` map in the state.\n\nThis function allows for adding or updating a specific attribute in the\nstate, useful for tracking individual properties in `Yex.DocServer`.","ref":"Yex.DocServer.State.html#assign/3"},{"type":"type","title":"Yex.DocServer.State.t/0","doc":"","ref":"Yex.DocServer.State.html#t:t/0"},{"type":"module","title":"Yex.Map","doc":"A shareable Map type that supports concurrent modifications with automatic conflict resolution.\nThis module provides functionality for collaborative key-value pair management with support for\nnested shared types and JSON compatibility.","ref":"Yex.Map.html"},{"type":"module","title":"Features - Yex.Map","doc":"- Concurrent modifications with automatic conflict resolution\n- Support for nested shared types (Array, Text, Map)\n- JSON-compatible serialization\n- Key-value pair management with atomic operations\n- Observable changes for real-time collaboration","ref":"Yex.Map.html#module-features"},{"type":"function","title":"Yex.Map.as_prelim/1","doc":"Converts the map to its preliminary representation.\nThis is useful when you need to serialize or transfer the map's contents.","ref":"Yex.Map.html#as_prelim/1"},{"type":"function","title":"Parameters - Yex.Map.as_prelim/1","doc":"* `map` - The map to convert","ref":"Yex.Map.html#as_prelim/1-parameters"},{"type":"function","title":"Yex.Map.delete/2","doc":"Deletes a key from the map.\nReturns :ok on success, :error on failure.","ref":"Yex.Map.html#delete/2"},{"type":"function","title":"Parameters - Yex.Map.delete/2","doc":"* `map` - The map to modify\n  * `key` - The key to delete","ref":"Yex.Map.html#delete/2-parameters"},{"type":"function","title":"Examples - Yex.Map.delete/2","doc":"iex> doc = Yex.Doc.new()\n    iex> map = Yex.Doc.get_map(doc, \"map\")\n    iex> Yex.Map.set(map, \"plane\", [\"Hello\", \"World\"])\n    iex> Yex.Map.delete(map, \"plane\")\n    :ok","ref":"Yex.Map.html#delete/2-examples"},{"type":"function","title":"Yex.Map.fetch/2","doc":"Retrieves a value by key from the map.\nReturns {:ok, value} if found, :error if not found.","ref":"Yex.Map.html#fetch/2"},{"type":"function","title":"Parameters - Yex.Map.fetch/2","doc":"* `map` - The map to query\n  * `key` - The key to look up","ref":"Yex.Map.html#fetch/2-parameters"},{"type":"function","title":"Examples - Yex.Map.fetch/2","doc":"iex> doc = Yex.Doc.new()\n    iex> map = Yex.Doc.get_map(doc, \"map\")\n    iex> Yex.Map.set(map, \"plane\", [\"Hello\", \"World\"])\n    iex> Yex.Map.fetch(map, \"plane\")\n    {:ok, [\"Hello\", \"World\"]}\n    iex> Yex.Map.fetch(map, \"not_found\")\n    :error","ref":"Yex.Map.html#fetch/2-examples"},{"type":"function","title":"Yex.Map.fetch!/2","doc":"Similar to fetch/2 but raises ArgumentError if the key is not found.","ref":"Yex.Map.html#fetch!/2"},{"type":"function","title":"Parameters - Yex.Map.fetch!/2","doc":"* `map` - The map to query\n  * `key` - The key to look up","ref":"Yex.Map.html#fetch!/2-parameters"},{"type":"function","title":"Raises - Yex.Map.fetch!/2","doc":"* ArgumentError - If the key is not found","ref":"Yex.Map.html#fetch!/2-raises"},{"type":"function","title":"Yex.Map.get/2","doc":"get a key from the map.","ref":"Yex.Map.html#get/2"},{"type":"function","title":"Examples - Yex.Map.get/2","doc":"iex> doc = Yex.Doc.new()\n    iex> map = Yex.Doc.get_map(doc, \"map\")\n    iex> Yex.Map.set(map, \"plane\", [\"Hello\", \"World\"])\n    iex> Yex.Map.get(map, \"plane\")\n    {:ok, [\"Hello\", \"World\"]}\n    iex> Yex.Map.get(map, \"not_found\")\n    :error","ref":"Yex.Map.html#get/2-examples"},{"type":"function","title":"Yex.Map.has_key?/2","doc":"Checks if a key exists in the map.\nReturns true if the key exists, false otherwise.","ref":"Yex.Map.html#has_key?/2"},{"type":"function","title":"Parameters - Yex.Map.has_key?/2","doc":"* `map` - The map to check\n  * `key` - The key to look for","ref":"Yex.Map.html#has_key?/2-parameters"},{"type":"function","title":"Yex.Map.set/3","doc":"Sets a key-value pair in the map.\nReturns :ok on success, :error on failure.","ref":"Yex.Map.html#set/3"},{"type":"function","title":"Parameters - Yex.Map.set/3","doc":"* `map` - The map to modify\n  * `key` - The key to set\n  * `content` - The value to associate with the key","ref":"Yex.Map.html#set/3-parameters"},{"type":"function","title":"Examples - Yex.Map.set/3","doc":"iex> doc = Yex.Doc.new()\n    iex> map = Yex.Doc.get_map(doc, \"map\")\n    iex> Yex.Map.set(map, \"plane\", [\"Hello\", \"World\"])\n    :ok","ref":"Yex.Map.html#set/3-examples"},{"type":"function","title":"Yex.Map.size/1","doc":"Returns the number of key-value pairs in the map.","ref":"Yex.Map.html#size/1"},{"type":"type","title":"Yex.Map.t/0","doc":"","ref":"Yex.Map.html#t:t/0"},{"type":"function","title":"Yex.Map.to_json/1","doc":"Converts the map to a JSON-compatible format.\nThis is useful for serialization or when you need to transfer the map's contents.","ref":"Yex.Map.html#to_json/1"},{"type":"function","title":"Examples - Yex.Map.to_json/1","doc":"iex> doc = Yex.Doc.new()\n    iex> map = Yex.Doc.get_map(doc, \"map\")\n    iex> Yex.Map.set(map, \"array\", Yex.ArrayPrelim.from([\"Hello\", \"World\"]))\n    iex> Yex.Map.set(map, \"plane\", [\"Hello\", \"World\"])\n    iex> assert %{\"plane\" => [\"Hello\", \"World\"], \"array\" => [\"Hello\", \"World\"]} = Yex.Map.to_json(map)","ref":"Yex.Map.html#to_json/1-examples"},{"type":"function","title":"Yex.Map.to_list/1","doc":"Converts the map to a list of key-value tuples.","ref":"Yex.Map.html#to_list/1"},{"type":"function","title":"Yex.Map.to_map/1","doc":"Converts the map to a standard Elixir map.\nThis is useful when you need to work with the map's contents in a non-collaborative context.","ref":"Yex.Map.html#to_map/1"},{"type":"function","title":"Examples - Yex.Map.to_map/1","doc":"iex> doc = Yex.Doc.new()\n    iex> map = Yex.Doc.get_map(doc, \"map\")\n    iex> Yex.Map.set(map, \"array\", Yex.ArrayPrelim.from([\"Hello\", \"World\"]))\n    iex> Yex.Map.set(map, \"plane\", [\"Hello\", \"World\"])\n    iex> assert %{\"plane\" => [\"Hello\", \"World\"], \"array\" => %Yex.Array{}} = Yex.Map.to_map(map)","ref":"Yex.Map.html#to_map/1-examples"},{"type":"module","title":"Yex.MapEvent","doc":"Event when Map type changes\n\n@see Yex.SharedType.observe/1\n@see Yex.SharedType.observe_deep/1","ref":"Yex.MapEvent.html"},{"type":"type","title":"Yex.MapEvent.change/0","doc":"","ref":"Yex.MapEvent.html#t:change/0"},{"type":"type","title":"Yex.MapEvent.keys/0","doc":"","ref":"Yex.MapEvent.html#t:keys/0"},{"type":"type","title":"Yex.MapEvent.t/0","doc":"","ref":"Yex.MapEvent.html#t:t/0"},{"type":"module","title":"Yex.MapPrelim","doc":"A preliminary map representation used for initializing map content.\nThis module provides functionality for creating map content before it is\ninserted into a shared document.","ref":"Yex.MapPrelim.html"},{"type":"module","title":"Use Cases - Yex.MapPrelim","doc":"- Creating map content before inserting into a document\n- Serializing map content for transfer between documents\n- Initializing map content with specific key-value pairs\n- Preparing nested data structures for shared documents","ref":"Yex.MapPrelim.html#module-use-cases"},{"type":"module","title":"Examples - Yex.MapPrelim","doc":"iex> doc = Yex.Doc.new()\n    iex> array = Yex.Doc.get_array(doc, \"array\")\n    iex> Yex.Array.insert(array, 0, Yex.MapPrelim.from(%{ \"key\" => \"value\" }))\n    iex> {:ok, %Yex.Map{} = map} = Yex.Array.fetch(array, 0)\n    iex> Yex.Map.fetch(map, \"key\")\n    {:ok, \"value\"}","ref":"Yex.MapPrelim.html#module-examples"},{"type":"function","title":"Yex.MapPrelim.from/1","doc":"Creates a new MapPrelim from an Elixir map.\nThis is useful when you want to initialize a shared map with predefined content.","ref":"Yex.MapPrelim.html#from/1"},{"type":"function","title":"Parameters - Yex.MapPrelim.from/1","doc":"* `map` - An Elixir map to convert to a preliminary map","ref":"Yex.MapPrelim.html#from/1-parameters"},{"type":"function","title":"Examples - Yex.MapPrelim.from/1","doc":"iex> prelim = Yex.MapPrelim.from(%{\"key\" => \"value\", \"nested\" => %{\"inner\" => \"data\"}})\n    iex> doc = Yex.Doc.new()\n    iex> map = Yex.Doc.get_map(doc, \"map\")\n    iex> Yex.Map.set(map, \"content\", prelim)","ref":"Yex.MapPrelim.html#from/1-examples"},{"type":"type","title":"Yex.MapPrelim.t/0","doc":"","ref":"Yex.MapPrelim.html#t:t/0"},{"type":"protocol","title":"Yex.Output","doc":"Protocol for converting shared types to their preliminary representations.\nThis is useful for serialization and data transfer between different parts of the system.","ref":"Yex.Output.html"},{"type":"function","title":"Yex.Output.as_prelim/1","doc":"Converts a shared type to its preliminary representation.\nThe preliminary representation is a simpler form that can be easily serialized or transferred.","ref":"Yex.Output.html#as_prelim/1"},{"type":"type","title":"Yex.Output.t/0","doc":"All the types that implement this protocol.","ref":"Yex.Output.html#t:t/0"},{"type":"module","title":"Yex.SharedType","doc":"The SharedType protocol defines the behavior of shared types in Yex.\nThis module provides functionality for observing changes to shared types,\nincluding arrays, maps, text, and XML nodes.","ref":"Yex.SharedType.html"},{"type":"function","title":"Yex.SharedType.observe/2","doc":"Registers a change observer that will be message every time this shared type is modified.\n\nIf the shared type changes, a message is delivered to the\nmonitoring process in the shape of:\n    {:observe_event, ref, event, origin, metadata}\n\nwhere:\n  * `ref` is a monitor reference returned by this function;\n  * `event` is a struct that describes the change;\n  * `origin` is the origin passed to the `Yex.Doc.transaction()` function.\n  * `metadata` is the metadata passed to the `observe` function.","ref":"Yex.SharedType.html#observe/2"},{"type":"function","title":"Options - Yex.SharedType.observe/2","doc":"* `:metadata` - provides metadata to be attached to this observe.","ref":"Yex.SharedType.html#observe/2-options"},{"type":"function","title":"Returns - Yex.SharedType.observe/2","doc":"* A reference that can be used to unsubscribe the observer","ref":"Yex.SharedType.html#observe/2-returns"},{"type":"function","title":"Yex.SharedType.observe_deep/2","doc":"Registers a change observer that will be message every time this shared type or any of its children is modified.\n\nIf the shared type changes, a message is delivered to the\nmonitoring process in the shape of:\n    {:observe_deep_event, ref, events, origin, metadata}\n\nwhere:\n  * `ref` is a monitor reference returned by this function;\n  * `events` is a list of structs that describes the changes;\n  * `origin` is the origin passed to the `Yex.Doc.transaction()` function.\n  * `metadata` is the metadata passed to the `observe_deep` function.","ref":"Yex.SharedType.html#observe_deep/2"},{"type":"function","title":"Options - Yex.SharedType.observe_deep/2","doc":"* `:metadata` - provides metadata to be attached to this observe.","ref":"Yex.SharedType.html#observe_deep/2-options"},{"type":"function","title":"Returns - Yex.SharedType.observe_deep/2","doc":"* A reference that can be used to unsubscribe the deep observer","ref":"Yex.SharedType.html#observe_deep/2-returns"},{"type":"type","title":"Yex.SharedType.t/0","doc":"","ref":"Yex.SharedType.html#t:t/0"},{"type":"function","title":"Yex.SharedType.unobserve/1","doc":"Unobserve the shared type for changes.\nRemoves the observer registered with the given reference.","ref":"Yex.SharedType.html#unobserve/1"},{"type":"function","title":"Yex.SharedType.unobserve_deep/1","doc":"Unobserve the shared type and its children for changes.\nRemoves the deep observer registered with the given reference.","ref":"Yex.SharedType.html#unobserve_deep/1"},{"type":"module","title":"Yex.StickyIndex","doc":"A sticky index provides position references that are unaffected by document changes, based on the Yjs model.\nIt maintains its relative position when placed before or after specific characters or elements.","ref":"Yex.StickyIndex.html"},{"type":"module","title":"Features - Yex.StickyIndex","doc":"- Stable position references unaffected by document changes\n- Compatible with shared types like Text, Array, and XML\n- Maintains relative positions after insert/delete operations\n- Ideal for tracking cursor positions and text selections","ref":"Yex.StickyIndex.html#module-features"},{"type":"module","title":"Usage - Yex.StickyIndex","doc":"Numeric indices are unsuitable for tracking user selections because their positions\nchange when content is inserted or deleted. Sticky indices provide stable references\nthat maintain their relative positions through such changes:\n\n    iex> alias Yex.{StickyIndex, Doc, Text}\n    iex> doc = Doc.new()\n    iex> txt = Doc.get_text(doc, \"text\")\n    iex> Doc.transaction(doc, fn ->\n    ...>  Text.insert(txt, 0, \"abc\")\n    ...>  # => 'abc'\n    ...>  # Create position tracker (marked as . in comments)\n    ...>  pos = StickyIndex.new(txt, 2, :after)\n    ...>  # => 'ab.c'\n    ...>\n    ...>  # Modify text\n    ...>  Text.insert(txt, 1, \"def\")\n    ...>  # => 'adefb.c'\n    ...>  Text.delete(txt, 4, 1)\n    ...>  # => 'adef.c'\n    ...>\n    ...>  # Get current offset index\n    ...>  {:ok, a} = StickyIndex.get_offset(pos)\n    ...>  # => 4\n    ...>  assert a.index == 4\n    ...> end)","ref":"Yex.StickyIndex.html#module-usage"},{"type":"function","title":"Yex.StickyIndex.get_offset/1","doc":"","ref":"Yex.StickyIndex.html#get_offset/1"},{"type":"function","title":"Yex.StickyIndex.new/3","doc":"","ref":"Yex.StickyIndex.html#new/3"},{"type":"type","title":"Yex.StickyIndex.shared_type/0","doc":"","ref":"Yex.StickyIndex.html#t:shared_type/0"},{"type":"type","title":"Yex.StickyIndex.t/0","doc":"","ref":"Yex.StickyIndex.html#t:t/0"},{"type":"module","title":"Yex.Subscription","doc":"Provides subscription functionality for monitoring changes in shared types.\nThis module implements features for observing changes in documents and other shared types,\nand receiving notifications when changes occur.","ref":"Yex.Subscription.html"},{"type":"module","title":"Features - Yex.Subscription","doc":"- Monitor change events in shared types\n- Process-level subscription management\n- Prevention of automatic resource release\n- Simple unsubscribe functionality","ref":"Yex.Subscription.html#module-features"},{"type":"module","title":"Usage - Yex.Subscription","doc":"Subscriptions are typically created by monitoring functions like `Yex.Doc.monitor_update/2`\nor `Yex.SharedType.observe/2` and are used to receive change notifications:\n\n    iex> doc = Yex.Doc.new()\n    iex> {:ok, ref} = Yex.Doc.monitor_update(doc)\n    iex> # Monitor changes...\n    iex> Yex.Subscription.unsubscribe(ref) # Unsubscribe from monitoring\n    :ok","ref":"Yex.Subscription.html#module-usage"},{"type":"function","title":"Yex.Subscription.register/2","doc":"Registers a subscription and returns a reference.\nThis function stores the subscription in the process dictionary to prevent\nautomatic release by the garbage collector.","ref":"Yex.Subscription.html#register/2"},{"type":"function","title":"Parameters - Yex.Subscription.register/2","doc":"* `sub` - The subscription to register\n  * `ref` - Optional reference. If not provided, a new reference will be generated","ref":"Yex.Subscription.html#register/2-parameters"},{"type":"function","title":"Returns - Yex.Subscription.register/2","doc":"* The subscription reference","ref":"Yex.Subscription.html#register/2-returns"},{"type":"type","title":"Yex.Subscription.t/0","doc":"","ref":"Yex.Subscription.html#t:t/0"},{"type":"function","title":"Yex.Subscription.unsubscribe/1","doc":"Unsubscribes from a subscription.\nRemoves the subscription associated with the given reference from the\nprocess dictionary and cleans up resources.","ref":"Yex.Subscription.html#unsubscribe/1"},{"type":"function","title":"Parameters - Yex.Subscription.unsubscribe/1","doc":"* `ref` - The reference of the subscription to unsubscribe","ref":"Yex.Subscription.html#unsubscribe/1-parameters"},{"type":"function","title":"Returns - Yex.Subscription.unsubscribe/1","doc":"* `:ok` - If unsubscription was successful","ref":"Yex.Subscription.html#unsubscribe/1-returns"},{"type":"module","title":"Yex.Sync","doc":"Yex.Sync provides functions to handle the synchronization protocol for Yex documents.\n\nThis module defines a set of message types and encoding/decoding functions to manage\ndocument state synchronization. The messages follow the protocol described in the\n[Yjs Sync Protocol Documentation](https://github.com/yjs/y-protocols/blob/33d220757004da44dc33172ec6aec3b94363052a/PROTOCOL.md#sync-protocol-v1-encoding).\nEach message type corresponds to a step in the sync process or an update to the document state.","ref":"Yex.Sync.html"},{"type":"function","title":"Yex.Sync.get_sync_step1/1","doc":"Generates a `sync_step1` message for initiating document synchronization. This message\ncontains the current encoded state vector of the document.\n\nReturns `{:ok, {:sync_step1, encoded_state_vector}}` if successful, otherwise an error.","ref":"Yex.Sync.html#get_sync_step1/1"},{"type":"function","title":"Yex.Sync.get_sync_step2/2","doc":"Creates a `sync_step2` message to continue synchronization using a given encoded state vector.\nThis message contains the current state of the document to be synchronized.\n\nReturns `{:ok, {:sync_step2, document_state}}` if successful, otherwise an error.","ref":"Yex.Sync.html#get_sync_step2/2"},{"type":"function","title":"Yex.Sync.get_update/1","doc":"Generates a `sync_update` message based on a provided update binary. This is typically\nused to apply incremental changes to the document state.\n\nReturns `{:ok, {:sync_update, update}}`.","ref":"Yex.Sync.html#get_update/1"},{"type":"type","title":"Yex.Sync.message/0","doc":"","ref":"Yex.Sync.html#t:message/0"},{"type":"function","title":"Yex.Sync.message_decode/1","doc":"Decodes a binary message into a recognized protocol format, returning `{:ok, message}`\nif decoding is successful, or `{:error, reason}` otherwise.","ref":"Yex.Sync.html#message_decode/1"},{"type":"function","title":"Examples - Yex.Sync.message_decode/1","doc":"iex> Yex.Sync.message_decode(<<0, 0, 1, 0>>)\n    {:ok, {:sync, {:sync_step1, <<0>>}}}","ref":"Yex.Sync.html#message_decode/1-examples"},{"type":"function","title":"Yex.Sync.message_decode!/1","doc":"Decodes a binary message, raising an error if decoding fails. Useful for cases where\nerror handling is managed at a higher level.","ref":"Yex.Sync.html#message_decode!/1"},{"type":"function","title":"Examples - Yex.Sync.message_decode!/1","doc":"iex> Yex.Sync.message_decode!(<<0, 0, 1, 0>>)\n    {:sync, {:sync_step1, <<0>>}}","ref":"Yex.Sync.html#message_decode!/1-examples"},{"type":"function","title":"Yex.Sync.message_decode_v1/1","doc":"","ref":"Yex.Sync.html#message_decode_v1/1"},{"type":"function","title":"Yex.Sync.message_decode_v2/1","doc":"","ref":"Yex.Sync.html#message_decode_v2/1"},{"type":"function","title":"Yex.Sync.message_encode/1","doc":"Encodes a message into binary format, returning `{:ok, binary}` if encoding\nsucceeds or `{:error, reason}` on failure.","ref":"Yex.Sync.html#message_encode/1"},{"type":"function","title":"Examples - Yex.Sync.message_encode/1","doc":"iex> Yex.Sync.message_encode({:sync, {:sync_step1, <<0>>}})\n    {:ok, <<0, 0, 1, 0>>}","ref":"Yex.Sync.html#message_encode/1-examples"},{"type":"function","title":"Yex.Sync.message_encode!/1","doc":"Encodes a message into binary format and raises an error if encoding fails.\nThis function is useful when error handling is managed externally.","ref":"Yex.Sync.html#message_encode!/1"},{"type":"function","title":"Yex.Sync.message_encode_v1/1","doc":"","ref":"Yex.Sync.html#message_encode_v1/1"},{"type":"function","title":"Yex.Sync.message_encode_v2/1","doc":"","ref":"Yex.Sync.html#message_encode_v2/1"},{"type":"function","title":"Yex.Sync.read_sync_message/3","doc":"Reads and applies a synchronization message to the document, based on the message type.\nSupports `sync_step1`, `sync_step2`, and `sync_update` messages, with each type invoking\nthe appropriate handler.\n\nReturns `{:ok, response}` on success or `{:error, :unknown_message}` if the message type is invalid.","ref":"Yex.Sync.html#read_sync_message/3"},{"type":"function","title":"Yex.Sync.read_sync_step1/2","doc":"Processes a `sync_step1` message to produce a `sync_step2` response, used to\nsynchronize document state.\n\nReturns `{:ok, {:sync_step2, document_state}}` if successful.","ref":"Yex.Sync.html#read_sync_step1/2"},{"type":"function","title":"Yex.Sync.read_sync_step2/3","doc":"Processes a `sync_step2` or `sync_update` message by applying the update to the document.\nThe update is applied within a transaction to ensure document consistency.\n\nReturns `:ok` on success, or `{:error, reason}` on failure.","ref":"Yex.Sync.html#read_sync_step2/3"},{"type":"type","title":"Yex.Sync.sync_message/0","doc":"","ref":"Yex.Sync.html#t:sync_message/0"},{"type":"type","title":"Yex.Sync.sync_message_step1/0","doc":"","ref":"Yex.Sync.html#t:sync_message_step1/0"},{"type":"type","title":"Yex.Sync.sync_message_step2/0","doc":"","ref":"Yex.Sync.html#t:sync_message_step2/0"},{"type":"type","title":"Yex.Sync.sync_message_update/0","doc":"","ref":"Yex.Sync.html#t:sync_message_update/0"},{"type":"module","title":"Yex.Sync.SharedDoc","doc":"This process handles messages for yjs protocol sync and awareness.\nhttps://github.com/yjs/y-protocols\n\nPersistence is supported by passing persistence module.\nsee Yex.Sync.SharedDoc.PersistenceBehaviour\n\nIf the observer process does not exist, it will automatically terminate.","ref":"Yex.Sync.SharedDoc.html"},{"type":"function","title":"Yex.Sync.SharedDoc.child_spec/1","doc":"","ref":"Yex.Sync.SharedDoc.html#child_spec/1"},{"type":"function","title":"Yex.Sync.SharedDoc.get_doc/1","doc":"Get the current state of the document.\n\nReturns the Doc struct that represents the current state of the shared document.\nNote: If you manipulate the structure obtained with this function from a different Node (Erlang VM node), some features may not work (e.g., observe). Please be careful.","ref":"Yex.Sync.SharedDoc.html#get_doc/1"},{"type":"type","title":"Yex.Sync.SharedDoc.launch_param/0","doc":"Launch Parameters\n\n  * `:doc_name` - The name of the document.\n  * `:persistence` - Persistence module that implements PersistenceBehaviour.\n  * `:auto_exit` - Automatically terminate the SharedDoc process when there is no longer a process to receive update notifications.\n  * `:doc_option` - Options for the document.","ref":"Yex.Sync.SharedDoc.html#t:launch_param/0"},{"type":"function","title":"Yex.Sync.SharedDoc.observe/1","doc":"Receive doc update notifications in the calling process.","ref":"Yex.Sync.SharedDoc.html#observe/1"},{"type":"function","title":"Yex.Sync.SharedDoc.process_message_v1/3","doc":"","ref":"Yex.Sync.SharedDoc.html#process_message_v1/3"},{"type":"function","title":"Yex.Sync.SharedDoc.send_yjs_message/2","doc":"Send a message to the SharedDoc process.\nmessage mus be represented in the Yjs protocol default format.\ntype supports sync and awareness.","ref":"Yex.Sync.SharedDoc.html#send_yjs_message/2"},{"type":"function","title":"Yex.Sync.SharedDoc.start/2","doc":"","ref":"Yex.Sync.SharedDoc.html#start/2"},{"type":"function","title":"Yex.Sync.SharedDoc.start_link/2","doc":"","ref":"Yex.Sync.SharedDoc.html#start_link/2"},{"type":"function","title":"Yex.Sync.SharedDoc.start_sync/2","doc":"Start the initial state exchange.","ref":"Yex.Sync.SharedDoc.html#start_sync/2"},{"type":"function","title":"Yex.Sync.SharedDoc.unobserve/1","doc":"Stop receiving doc update notifications in the calling process.\n\nIf auto_exit is started with true(default), the SharedDoc process will automatically stop when there is no longer a process to receive update notifications.","ref":"Yex.Sync.SharedDoc.html#unobserve/1"},{"type":"function","title":"Yex.Sync.SharedDoc.update_doc/3","doc":"Update the document with the given function.\n\nThe function should take a Doc struct as its argument and modify it as needed.\nThe timeout parameter specifies how long to wait for the update to complete (defaults to 5000ms).\n\nReturns :ok on success or {:error, reason} on failure.","ref":"Yex.Sync.SharedDoc.html#update_doc/3"},{"type":"function","title":"Examples - Yex.Sync.SharedDoc.update_doc/3","doc":"iex> {:ok, shared_doc} = SharedDoc.start_link(doc_name: \"document_name\")\n    iex> SharedDoc.update_doc(shared_doc, fn doc -> Yex.Doc.get_array(doc, \"array\") |> Array.insert(0, \"updated_data\") end) # update the document\n    :ok\n    iex> SharedDoc.get_doc(shared_doc) |> Yex.Doc.get_array(\"array\") |> Yex.Array.to_json() # check the update\n    [\"updated_data\"]","ref":"Yex.Sync.SharedDoc.html#update_doc/3-examples"},{"type":"behaviour","title":"Yex.Sync.SharedDoc.PersistenceBehaviour","doc":"Persistence behavior for SharedDoc","ref":"Yex.Sync.SharedDoc.PersistenceBehaviour.html"},{"type":"callback","title":"Yex.Sync.SharedDoc.PersistenceBehaviour.bind/3","doc":"Invoked to handle SharedDoc bind.\nMainly used to read and set the initial values of SharedDoc","ref":"Yex.Sync.SharedDoc.PersistenceBehaviour.html#c:bind/3"},{"type":"callback","title":"Examples save the state to the filesystem - Yex.Sync.SharedDoc.PersistenceBehaviour.bind/3","doc":"def bind(state, doc_name, doc) do\n    case File.read(\"path/to/\" <> doc_name, [:read, :binary]) do\n      {:ok, data} ->\n        Yex.apply_update(doc, data)\n\n      {:error, _} ->\n        :ok\n    end\n  end","ref":"Yex.Sync.SharedDoc.PersistenceBehaviour.html#c:bind/3-examples-save-the-state-to-the-filesystem"},{"type":"callback","title":"Yex.Sync.SharedDoc.PersistenceBehaviour.unbind/3","doc":"Invoked to handle SharedDoc terminate.\n\nThis is only executed when SharedDoc exits successfully.","ref":"Yex.Sync.SharedDoc.PersistenceBehaviour.html#c:unbind/3"},{"type":"callback","title":"Examples save the state to the filesystem - Yex.Sync.SharedDoc.PersistenceBehaviour.unbind/3","doc":"def unbind(state, doc_name, doc) do\n      case Yex.encode_state_as_update(doc) do\n        {:ok, update} ->\n          File.write!(\"path/to/\" <> doc_name, update, [:write, :binary])\n        error ->\n          error\n      end\n\n      :ok\n    end","ref":"Yex.Sync.SharedDoc.PersistenceBehaviour.html#c:unbind/3-examples-save-the-state-to-the-filesystem"},{"type":"callback","title":"Yex.Sync.SharedDoc.PersistenceBehaviour.update_v1/4","doc":"Invoked to handle all doc updates.","ref":"Yex.Sync.SharedDoc.PersistenceBehaviour.html#c:update_v1/4"},{"type":"module","title":"Yex.Text","doc":"A shareable type that is optimized for shared editing on text.\nThis module provides functionality for collaborative text editing with support for rich text formatting.","ref":"Yex.Text.html"},{"type":"module","title":"Features - Yex.Text","doc":"- Insert and delete text at any position\n- Apply formatting attributes (bold, italic, etc.)\n- Support for Quill Delta format for change tracking\n- Collaborative editing with conflict resolution","ref":"Yex.Text.html#module-features"},{"type":"function","title":"Yex.Text.apply_delta/2","doc":"Transforms this type to a Quill Delta","ref":"Yex.Text.html#apply_delta/2"},{"type":"function","title":"Examples Syncs two clients by exchanging the complete document structure - Yex.Text.apply_delta/2","doc":"iex> doc = Yex.Doc.new()\n    iex> text = Yex.Doc.get_text(doc, \"text\")\n    iex> delta = [%{ \"retain\" => 1}, %{ \"delete\" => 3}]\n    iex> Yex.Text.insert(text,0, \"12345\")\n    iex> Yex.Text.apply_delta(text,delta)\n    iex> Yex.Text.to_delta(text)\n    [%{insert: \"15\"}]","ref":"Yex.Text.html#apply_delta/2-examples-syncs-two-clients-by-exchanging-the-complete-document-structure"},{"type":"function","title":"Yex.Text.as_prelim/1","doc":"Converts the text object to its preliminary representation.\nThis is useful when you need to serialize or transfer the text content and formatting.","ref":"Yex.Text.html#as_prelim/1"},{"type":"function","title":"Parameters - Yex.Text.as_prelim/1","doc":"* `text` - The text object to convert","ref":"Yex.Text.html#as_prelim/1-parameters"},{"type":"function","title":"Yex.Text.delete/3","doc":"Deletes text content starting at the specified index.\nSupports negative indices for deletion from the end.\nReturns :ok on success, :error on failure.","ref":"Yex.Text.html#delete/3"},{"type":"function","title":"Parameters - Yex.Text.delete/3","doc":"* `text` - The text object to modify\n  * `index` - The starting position to delete from (0-based, negative indices count from end)\n  * `length` - The number of characters to delete","ref":"Yex.Text.html#delete/3-parameters"},{"type":"type","title":"Yex.Text.delta/0","doc":"","ref":"Yex.Text.html#t:delta/0"},{"type":"function","title":"Yex.Text.format/4","doc":"Applies formatting attributes to a range of text.\nReturns :ok on success, :error on failure.","ref":"Yex.Text.html#format/4"},{"type":"function","title":"Parameters - Yex.Text.format/4","doc":"* `text` - The text object to modify\n  * `index` - The starting position to format from (0-based)\n  * `length` - The number of characters to format\n  * `attr` - A map of formatting attributes to apply (e.g. %{\"bold\" => true})","ref":"Yex.Text.html#format/4-parameters"},{"type":"function","title":"Yex.Text.insert/3","doc":"Inserts text content at the specified index.\nReturns :ok on success, :error on failure.","ref":"Yex.Text.html#insert/3"},{"type":"function","title":"Parameters - Yex.Text.insert/3","doc":"* `text` - The text object to modify\n  * `index` - The position to insert at (0-based)\n  * `content` - The text content to insert","ref":"Yex.Text.html#insert/3-parameters"},{"type":"function","title":"Yex.Text.insert/4","doc":"Inserts text content with formatting attributes at the specified index.\nReturns :ok on success, :error on failure.","ref":"Yex.Text.html#insert/4"},{"type":"function","title":"Parameters - Yex.Text.insert/4","doc":"* `text` - The text object to modify\n  * `index` - The position to insert at (0-based)\n  * `content` - The text content to insert\n  * `attr` - A map of formatting attributes to apply (e.g. %{\"bold\" => true})","ref":"Yex.Text.html#insert/4-parameters"},{"type":"function","title":"Yex.Text.length/1","doc":"Returns the length of the text content in characters.","ref":"Yex.Text.html#length/1"},{"type":"function","title":"Parameters - Yex.Text.length/1","doc":"* `text` - The text object to get the length of","ref":"Yex.Text.html#length/1-parameters"},{"type":"type","title":"Yex.Text.t/0","doc":"","ref":"Yex.Text.html#t:t/0"},{"type":"function","title":"Yex.Text.to_delta/1","doc":"Transforms this type to a Quill Delta","ref":"Yex.Text.html#to_delta/1"},{"type":"function","title":"Examples creates a few changes, then gets them back as a batch of change maps - Yex.Text.to_delta/1","doc":"iex> doc = Yex.Doc.new()\n    iex> text = Yex.Doc.get_text(doc, \"text\")\n    iex> Yex.Text.insert(text, 0, \"12345\")\n    iex> Yex.Text.insert(text, 0, \"0\", %{\"bold\" => true})\n    iex> Yex.Text.to_delta(text)\n    [%{insert: \"0\", attributes: %{\"bold\" => true}}, %{insert: \"12345\"}]","ref":"Yex.Text.html#to_delta/1-examples-creates-a-few-changes-then-gets-them-back-as-a-batch-of-change-maps"},{"type":"function","title":"Yex.Text.to_string/1","doc":"Returns the text content as a string.","ref":"Yex.Text.html#to_string/1"},{"type":"function","title":"Parameters - Yex.Text.to_string/1","doc":"* `text` - The text object to convert to string","ref":"Yex.Text.html#to_string/1-parameters"},{"type":"module","title":"Yex.TextEvent","doc":"Event when Text type changes\n\n@see Yex.SharedType.observe/1\n@see Yex.SharedType.observe_deep/1","ref":"Yex.TextEvent.html"},{"type":"type","title":"Yex.TextEvent.t/0","doc":"","ref":"Yex.TextEvent.html#t:t/0"},{"type":"module","title":"Yex.TextPrelim","doc":"A preliminary text representation used for initializing text content.\nThis module provides functionality for creating text content with formatting\nbefore it is inserted into a shared document.","ref":"Yex.TextPrelim.html"},{"type":"module","title":"Use Cases - Yex.TextPrelim","doc":"- Creating formatted text content before inserting into a document\n- Serializing text content for transfer between documents\n- Initializing text content with specific formatting attributes","ref":"Yex.TextPrelim.html#module-use-cases"},{"type":"module","title":"Examples - Yex.TextPrelim","doc":"iex> doc = Yex.Doc.new()\n    iex> map = Yex.Doc.get_map(doc, \"map\")\n    iex> Yex.Map.set(map, \"key\", Yex.TextPrelim.from(\"Hello World\"))\n    iex> {:ok, %Yex.Text{} = text} = Yex.Map.fetch(map, \"key\")\n    iex> Yex.Text.to_delta(text)\n    [%{insert: \"Hello World\"}]","ref":"Yex.TextPrelim.html#module-examples"},{"type":"function","title":"Yex.TextPrelim.from/1","doc":"Creates a new TextPrelim from either a binary string or a delta format.","ref":"Yex.TextPrelim.html#from/1"},{"type":"function","title":"Examples with a binary string - Yex.TextPrelim.from/1","doc":"iex> doc = Yex.Doc.new()\n    iex> map = Yex.Doc.get_map(doc, \"map\")\n    iex> Yex.Map.set(map, \"key\", Yex.TextPrelim.from(\"Hello World\"))\n    iex> {:ok, %Yex.Text{} = text} = Yex.Map.fetch(map, \"key\")\n    iex> Yex.Text.to_delta(text)\n    [%{insert: \"Hello World\"}]","ref":"Yex.TextPrelim.html#from/1-examples-with-a-binary-string"},{"type":"function","title":"Examples with formatted delta - Yex.TextPrelim.from/1","doc":"iex> doc = Yex.Doc.new()\n    iex> map = Yex.Doc.get_map(doc, \"map\")\n    iex> Yex.Map.set(map, \"key\", Yex.TextPrelim.from([%{insert: \"Hello\"},%{insert: \" World\", attributes: %{ \"bold\" => true }},]))\n    iex> {:ok, %Yex.Text{} = text} = Yex.Map.fetch(map, \"key\")\n    iex> Yex.Text.to_delta(text)\n    [%{insert: \"Hello\"}, %{attributes: %{\"bold\" => true}, insert: \" World\"}]","ref":"Yex.TextPrelim.html#from/1-examples-with-formatted-delta"},{"type":"function","title":"Parameters - Yex.TextPrelim.from/1","doc":"* `text` - Either a binary string or a delta format array","ref":"Yex.TextPrelim.html#from/1-parameters"},{"type":"type","title":"Yex.TextPrelim.t/0","doc":"","ref":"Yex.TextPrelim.html#t:t/0"},{"type":"module","title":"Yex.UndoManager","doc":"Represents a Y.UndoManager instance.","ref":"Yex.UndoManager.html"},{"type":"function","title":"Yex.UndoManager.clear/1","doc":"Clears all StackItems stored within current UndoManager, effectively resetting its state.","ref":"Yex.UndoManager.html#clear/1"},{"type":"function","title":"Example: - Yex.UndoManager.clear/1","doc":"text = Doc.get_text(doc, \"text\")\n    undo_manager = UndoManager.new(doc, text)\n\n    Text.insert(text, 0, \"Hello\")\n    Text.insert(text, 5, \" World\")\n    UndoManager.clear(undo_manager)\n    # All undo/redo history is now cleared","ref":"Yex.UndoManager.html#clear/1-example"},{"type":"function","title":"Yex.UndoManager.exclude_origin/2","doc":"Excludes an origin from being tracked by the UndoManager.","ref":"Yex.UndoManager.html#exclude_origin/2"},{"type":"function","title":"Yex.UndoManager.expand_scope/2","doc":"Expands the scope of the UndoManager to include additional shared types.\nThe scope can be a Text, Array, or Map type.","ref":"Yex.UndoManager.html#expand_scope/2"},{"type":"function","title":"Yex.UndoManager.include_origin/2","doc":"Includes an origin to be tracked by the UndoManager.","ref":"Yex.UndoManager.html#include_origin/2"},{"type":"macro","title":"Yex.UndoManager.is_valid_scope/1","doc":"","ref":"Yex.UndoManager.html#is_valid_scope/1"},{"type":"function","title":"Yex.UndoManager.new/2","doc":"Creates a new UndoManager for the given document and scope with default options.\nThe scope can be a Text, Array, Map, XmlText, XmlElement, or XmlFragment type.","ref":"Yex.UndoManager.html#new/2"},{"type":"function","title":"Errors - Yex.UndoManager.new/2","doc":"- Returns `{:error, \"Invalid scope: expected a struct\"}` if scope is not a struct\n- Returns `{:error, \"Failed to get branch reference\"}` if there's an error accessing the scope","ref":"Yex.UndoManager.html#new/2-errors"},{"type":"function","title":"Yex.UndoManager.new_with_options/3","doc":"Creates a new UndoManager with the given options.","ref":"Yex.UndoManager.html#new_with_options/3"},{"type":"function","title":"Options - Yex.UndoManager.new_with_options/3","doc":"See `Yex.UndoManager.Options` for available options.","ref":"Yex.UndoManager.html#new_with_options/3-options"},{"type":"function","title":"Errors - Yex.UndoManager.new_with_options/3","doc":"- Returns `{:error, \"NIF error:  \"}` if underlying NIF returns an error","ref":"Yex.UndoManager.html#new_with_options/3-errors"},{"type":"function","title":"Yex.UndoManager.redo/1","doc":"Redoes the last undone change.","ref":"Yex.UndoManager.html#redo/1"},{"type":"function","title":"Yex.UndoManager.stop_capturing/1","doc":"Stops capturing changes for the current stack item.\nThis ensures that the next change will create a new stack item instead of\nbeing merged with the previous one, even if it occurs within the normal timeout window.","ref":"Yex.UndoManager.html#stop_capturing/1"},{"type":"function","title":"Example: - Yex.UndoManager.stop_capturing/1","doc":"text = Doc.get_text(doc, \"text\")\n    undo_manager = UndoManager.new(doc, text)\n\n    Text.insert(text, 0, \"a\")\n    UndoManager.stop_capturing(undo_manager)\n    Text.insert(text, 1, \"b\")\n    UndoManager.undo(undo_manager)\n    # Text.to_string(text) will be \"a\" (only \"b\" was removed)","ref":"Yex.UndoManager.html#stop_capturing/1-example"},{"type":"type","title":"Yex.UndoManager.t/0","doc":"","ref":"Yex.UndoManager.html#t:t/0"},{"type":"function","title":"Yex.UndoManager.undo/1","doc":"Undoes the last tracked change.","ref":"Yex.UndoManager.html#undo/1"},{"type":"module","title":"Yex.UndoManager.Options","doc":"Options for creating an UndoManager.\n\n* `:capture_timeout` - Time in milliseconds to wait before creating a new capture group","ref":"Yex.UndoManager.Options.html"},{"type":"type","title":"Yex.UndoManager.Options.t/0","doc":"","ref":"Yex.UndoManager.Options.html#t:t/0"},{"type":"protocol","title":"Yex.Xml","doc":"Defines a protocol for XML node operations.\nThis protocol provides basic navigation and string conversion functionality for XML nodes.","ref":"Yex.Xml.html"},{"type":"function","title":"Yex.Xml.next_sibling/1","doc":"Returns the next sibling node of the current node.","ref":"Yex.Xml.html#next_sibling/1"},{"type":"function","title":"Yex.Xml.parent/1","doc":"Returns the parent node of the current node.","ref":"Yex.Xml.html#parent/1"},{"type":"function","title":"Yex.Xml.prev_sibling/1","doc":"Returns the previous sibling node of the current node.","ref":"Yex.Xml.html#prev_sibling/1"},{"type":"type","title":"Yex.Xml.t/0","doc":"All the types that implement this protocol.","ref":"Yex.Xml.html#t:t/0"},{"type":"function","title":"Yex.Xml.to_string/1","doc":"Converts the XML node to its string representation.","ref":"Yex.Xml.html#to_string/1"},{"type":"module","title":"Yex.XmlElement","doc":"A shared type that represents an XML node.\nProvides functionality for manipulating XML elements including child nodes, attributes, and navigation.","ref":"Yex.XmlElement.html"},{"type":"function","title":"Yex.XmlElement.as_prelim/1","doc":"","ref":"Yex.XmlElement.html#as_prelim/1"},{"type":"function","title":"Yex.XmlElement.children/1","doc":"Returns a stream of all child nodes of the XML element.","ref":"Yex.XmlElement.html#children/1"},{"type":"function","title":"Yex.XmlElement.delete/3","doc":"Deletes a range of child nodes starting at the specified index.\nReturns :ok on success, :error on failure.","ref":"Yex.XmlElement.html#delete/3"},{"type":"function","title":"Yex.XmlElement.fetch/2","doc":"Retrieves the child node at the specified index.\nReturns {:ok, node} if found, :error if index is out of bounds.","ref":"Yex.XmlElement.html#fetch/2"},{"type":"function","title":"Yex.XmlElement.fetch!/2","doc":"Similar to fetch/2 but raises ArgumentError if the index is out of bounds.","ref":"Yex.XmlElement.html#fetch!/2"},{"type":"function","title":"Yex.XmlElement.first_child/1","doc":"Returns the first child node of the XML element.\nReturns nil if the element has no children.","ref":"Yex.XmlElement.html#first_child/1"},{"type":"function","title":"Yex.XmlElement.get/2","doc":"","ref":"Yex.XmlElement.html#get/2"},{"type":"function","title":"Yex.XmlElement.get_attribute/2","doc":"Returns the value of the specified attribute.\nReturns nil if the attribute does not exist.","ref":"Yex.XmlElement.html#get_attribute/2"},{"type":"function","title":"Yex.XmlElement.get_attributes/1","doc":"Returns a map of all attributes for this XML element.","ref":"Yex.XmlElement.html#get_attributes/1"},{"type":"function","title":"Yex.XmlElement.get_tag/1","doc":"Returns the tag name of the XML element.\nReturns nil if the element has no tag.","ref":"Yex.XmlElement.html#get_tag/1"},{"type":"function","title":"Yex.XmlElement.insert/3","doc":"Inserts a new child node at the specified index.\nReturns :ok on success, :error on failure.","ref":"Yex.XmlElement.html#insert/3"},{"type":"function","title":"Yex.XmlElement.insert_after/3","doc":"Inserts a new child node after the specified reference node.\nIf the reference node is not found, inserts at the beginning.\nReturns :ok on success, :error on failure.","ref":"Yex.XmlElement.html#insert_after/3"},{"type":"function","title":"Yex.XmlElement.insert_attribute/3","doc":"Adds or updates an attribute with the specified key and value.\nReturns :ok on success, :error on failure.","ref":"Yex.XmlElement.html#insert_attribute/3"},{"type":"function","title":"Yex.XmlElement.length/1","doc":"Returns the number of child nodes in the XML element.","ref":"Yex.XmlElement.html#length/1"},{"type":"function","title":"Yex.XmlElement.next_sibling/1","doc":"The next sibling of this type. Is null if this is the last child of its parent.","ref":"Yex.XmlElement.html#next_sibling/1"},{"type":"function","title":"Yex.XmlElement.parent/1","doc":"The parent that holds this type. Is null if this xml is a top-level XML type.","ref":"Yex.XmlElement.html#parent/1"},{"type":"function","title":"Yex.XmlElement.prev_sibling/1","doc":"The previous sibling of this type. Is null if this is the first child of its parent.","ref":"Yex.XmlElement.html#prev_sibling/1"},{"type":"function","title":"Yex.XmlElement.push/2","doc":"Appends a new child node at the end of the children list.\nReturns :ok on success, :error on failure.","ref":"Yex.XmlElement.html#push/2"},{"type":"function","title":"Yex.XmlElement.remove_attribute/2","doc":"Removes the attribute with the specified key.\nReturns :ok on success, :error on failure.","ref":"Yex.XmlElement.html#remove_attribute/2"},{"type":"type","title":"Yex.XmlElement.t/0","doc":"","ref":"Yex.XmlElement.html#t:t/0"},{"type":"function","title":"Yex.XmlElement.to_string/1","doc":"","ref":"Yex.XmlElement.html#to_string/1"},{"type":"function","title":"Yex.XmlElement.unshift/2","doc":"Inserts a new child node at the beginning of the children list.\nReturns :ok on success, :error on failure.","ref":"Yex.XmlElement.html#unshift/2"},{"type":"module","title":"Yex.XmlElementPrelim","doc":"A preliminary xml element. It can be used to early initialize the contents of a XmlElement.","ref":"Yex.XmlElementPrelim.html"},{"type":"module","title":"Examples - Yex.XmlElementPrelim","doc":"iex> doc = Yex.Doc.new()\n    iex> xml = Yex.Doc.get_xml_fragment(doc, \"xml\")\n    iex> Yex.XmlFragment.insert(xml, 0,  Yex.XmlElementPrelim.empty(\"div\"))\n    iex> Yex.XmlFragment.to_string(xml)\n    \"  \"","ref":"Yex.XmlElementPrelim.html#module-examples"},{"type":"function","title":"Yex.XmlElementPrelim.empty/1","doc":"","ref":"Yex.XmlElementPrelim.html#empty/1"},{"type":"function","title":"Yex.XmlElementPrelim.new/3","doc":"","ref":"Yex.XmlElementPrelim.html#new/3"},{"type":"type","title":"Yex.XmlElementPrelim.t/0","doc":"","ref":"Yex.XmlElementPrelim.html#t:t/0"},{"type":"module","title":"Yex.XmlEvent","doc":"Event when XMLFragment/Element type changes\n\n@see Yex.SharedType.observe/1\n@see Yex.SharedType.observe_deep/1","ref":"Yex.XmlEvent.html"},{"type":"type","title":"Yex.XmlEvent.t/0","doc":"","ref":"Yex.XmlEvent.html#t:t/0"},{"type":"module","title":"Yex.XmlFragment","doc":"A shared type to manage a collection of XML nodes.\nProvides functionality for manipulating XML fragments including child nodes and navigation.","ref":"Yex.XmlFragment.html"},{"type":"function","title":"Yex.XmlFragment.as_prelim/1","doc":"Converts the XML fragment to a preliminary representation.\nThis is useful when you need to serialize or transfer the fragment's structure.","ref":"Yex.XmlFragment.html#as_prelim/1"},{"type":"function","title":"Yex.XmlFragment.children/1","doc":"Returns a stream of all child nodes of the XML fragment.","ref":"Yex.XmlFragment.html#children/1"},{"type":"function","title":"Yex.XmlFragment.delete/3","doc":"Deletes a range of child nodes starting at the specified index.\nReturns :ok on success, :error on failure.","ref":"Yex.XmlFragment.html#delete/3"},{"type":"function","title":"Yex.XmlFragment.fetch/2","doc":"Retrieves the child node at the specified index.\nReturns {:ok, node} if found, :error if index is out of bounds.","ref":"Yex.XmlFragment.html#fetch/2"},{"type":"function","title":"Yex.XmlFragment.fetch!/2","doc":"Similar to fetch/2 but raises ArgumentError if the index is out of bounds.","ref":"Yex.XmlFragment.html#fetch!/2"},{"type":"function","title":"Yex.XmlFragment.first_child/1","doc":"Returns the first child node of the XML fragment.\nReturns nil if the fragment has no children.","ref":"Yex.XmlFragment.html#first_child/1"},{"type":"function","title":"Yex.XmlFragment.get/2","doc":"","ref":"Yex.XmlFragment.html#get/2"},{"type":"function","title":"Yex.XmlFragment.insert/3","doc":"Inserts a new child node at the specified index.\nReturns :ok on success, :error on failure.","ref":"Yex.XmlFragment.html#insert/3"},{"type":"function","title":"Yex.XmlFragment.insert_after/3","doc":"Inserts a new child node after the specified reference node.\nIf the reference node is not found, inserts at the beginning.\nReturns :ok on success, :error on failure.","ref":"Yex.XmlFragment.html#insert_after/3"},{"type":"function","title":"Yex.XmlFragment.length/1","doc":"Returns the number of child nodes in the XML fragment.","ref":"Yex.XmlFragment.html#length/1"},{"type":"function","title":"Yex.XmlFragment.parent/1","doc":"Returns the parent node of this fragment.\nReturns nil if this is a top-level XML fragment.","ref":"Yex.XmlFragment.html#parent/1"},{"type":"function","title":"Yex.XmlFragment.push/2","doc":"Appends a new child node at the end of the children list.\nReturns :ok on success, :error on failure.","ref":"Yex.XmlFragment.html#push/2"},{"type":"type","title":"Yex.XmlFragment.t/0","doc":"","ref":"Yex.XmlFragment.html#t:t/0"},{"type":"function","title":"Yex.XmlFragment.to_string/1","doc":"Returns a string representation of the XML fragment and all its child nodes.","ref":"Yex.XmlFragment.html#to_string/1"},{"type":"function","title":"Yex.XmlFragment.unshift/2","doc":"Inserts a new child node at the beginning of the children list.\nReturns :ok on success, :error on failure.","ref":"Yex.XmlFragment.html#unshift/2"},{"type":"module","title":"Yex.XmlFragmentPrelim","doc":"A preliminary xml fragment. It can be used to early initialize the contents of a XmlFragment.","ref":"Yex.XmlFragmentPrelim.html"},{"type":"module","title":"Examples - Yex.XmlFragmentPrelim","doc":"iex> doc = Yex.Doc.new()\n    iex> array = Yex.Doc.get_array(doc, \"array\")\n    iex> Yex.Array.insert(array, 0,  Yex.XmlFragmentPrelim.new([Yex.XmlElementPrelim.empty(\"div\")]))\n    iex> {:ok, %Yex.XmlFragment{} = fragment} = Yex.Array.fetch(array, 0)\n    iex> Yex.XmlFragment.to_string(fragment)\n    \"  \"","ref":"Yex.XmlFragmentPrelim.html#module-examples"},{"type":"function","title":"Yex.XmlFragmentPrelim.new/1","doc":"Creates a new preliminary XML fragment with the given children.\nThe children can be a mix of XmlElementPrelim and XmlTextPrelim nodes.","ref":"Yex.XmlFragmentPrelim.html#new/1"},{"type":"function","title":"Parameters - Yex.XmlFragmentPrelim.new/1","doc":"* `children` - A list or enumerable of preliminary XML nodes (elements or text)","ref":"Yex.XmlFragmentPrelim.html#new/1-parameters"},{"type":"function","title":"Returns - Yex.XmlFragmentPrelim.new/1","doc":"* A new XmlFragmentPrelim struct containing the provided children","ref":"Yex.XmlFragmentPrelim.html#new/1-returns"},{"type":"type","title":"Yex.XmlFragmentPrelim.t/0","doc":"","ref":"Yex.XmlFragmentPrelim.html#t:t/0"},{"type":"module","title":"Yex.XmlText","doc":"A shared type that represents an XML text node.\nExtends Y.Text to provide functionality for manipulating text content within XML nodes,\nincluding text formatting and navigation.","ref":"Yex.XmlText.html"},{"type":"function","title":"Yex.XmlText.apply_delta/2","doc":"Applies a delta of changes to the text content.\nReturns :ok on success, :error on failure.","ref":"Yex.XmlText.html#apply_delta/2"},{"type":"function","title":"Yex.XmlText.as_prelim/1","doc":"Converts the XML text node to a preliminary representation.\nThis is useful when you need to serialize or transfer the text node's content and formatting.","ref":"Yex.XmlText.html#as_prelim/1"},{"type":"function","title":"Yex.XmlText.delete/3","doc":"Deletes text content starting at the specified index.\nSupports negative indices for deletion from the end.\nReturns :ok on success, :error on failure.","ref":"Yex.XmlText.html#delete/3"},{"type":"type","title":"Yex.XmlText.delta/0","doc":"","ref":"Yex.XmlText.html#t:delta/0"},{"type":"function","title":"Yex.XmlText.format/4","doc":"Applies formatting attributes to a range of text.\nReturns :ok on success, :error on failure.","ref":"Yex.XmlText.html#format/4"},{"type":"function","title":"Yex.XmlText.insert/3","doc":"Inserts text content at the specified index.\nReturns :ok on success, :error on failure.","ref":"Yex.XmlText.html#insert/3"},{"type":"function","title":"Yex.XmlText.insert/4","doc":"Inserts text content with attributes at the specified index.\nReturns :ok on success, :error on failure.","ref":"Yex.XmlText.html#insert/4"},{"type":"function","title":"Yex.XmlText.length/1","doc":"Returns the length of the text content.","ref":"Yex.XmlText.html#length/1"},{"type":"function","title":"Yex.XmlText.next_sibling/1","doc":"Returns the next sibling node of this text node.\nReturns nil if this is the last child of its parent.","ref":"Yex.XmlText.html#next_sibling/1"},{"type":"function","title":"Yex.XmlText.parent/1","doc":"Returns the parent node of this text node.\nReturns nil if this is a top-level XML node.","ref":"Yex.XmlText.html#parent/1"},{"type":"function","title":"Yex.XmlText.prev_sibling/1","doc":"Returns the previous sibling node of this text node.\nReturns nil if this is the first child of its parent.","ref":"Yex.XmlText.html#prev_sibling/1"},{"type":"type","title":"Yex.XmlText.t/0","doc":"","ref":"Yex.XmlText.html#t:t/0"},{"type":"function","title":"Yex.XmlText.to_delta/1","doc":"Returns the text content as a delta format, including any formatting attributes.","ref":"Yex.XmlText.html#to_delta/1"},{"type":"function","title":"Yex.XmlText.to_string/1","doc":"Returns the text content as a string, including any formatting tags.","ref":"Yex.XmlText.html#to_string/1"},{"type":"module","title":"Yex.XmlTextEvent","doc":"Event when Text type changes\n\n@see Yex.SharedType.observe/1\n@see Yex.SharedType.observe_deep/1","ref":"Yex.XmlTextEvent.html"},{"type":"type","title":"Yex.XmlTextEvent.t/0","doc":"","ref":"Yex.XmlTextEvent.html#t:t/0"},{"type":"module","title":"Yex.XmlTextPrelim","doc":"A preliminary xml text. It can be used to early initialize the contents of a XmlText.","ref":"Yex.XmlTextPrelim.html"},{"type":"module","title":"Examples - Yex.XmlTextPrelim","doc":"iex> doc = Yex.Doc.new()\n    iex> xml = Yex.Doc.get_xml_fragment(doc, \"xml\")\n    iex> Yex.XmlFragment.insert(xml, 0,  Yex.XmlTextPrelim.from(\"Hello World\"))\n    iex> {:ok, %Yex.XmlText{} = text} = Yex.XmlFragment.fetch(xml, 0)\n    iex> Yex.XmlText.to_delta(text)\n    [%{insert: \"Hello World\"}]","ref":"Yex.XmlTextPrelim.html#module-examples"},{"type":"function","title":"Yex.XmlTextPrelim.from/1","doc":"Transforms a Text to a TextPrelim","ref":"Yex.XmlTextPrelim.html#from/1"},{"type":"function","title":"Examples with a binary - Yex.XmlTextPrelim.from/1","doc":"iex> doc = Yex.Doc.new()\n    iex> map = Yex.Doc.get_map(doc, \"map\")\n    iex> Yex.Map.set(map, \"key\", Yex.XmlTextPrelim.from(\"Hello World\"))\n    iex> {:ok, %Yex.XmlText{} = text} = Yex.Map.fetch(map, \"key\")\n    iex> Yex.XmlText.to_delta(text)\n    [%{insert: \"Hello World\"}]","ref":"Yex.XmlTextPrelim.html#from/1-examples-with-a-binary"},{"type":"function","title":"Examples with delta - Yex.XmlTextPrelim.from/1","doc":"iex> doc = Yex.Doc.new()\n    iex> map = Yex.Doc.get_map(doc, \"map\")\n    iex> Yex.Map.set(map, \"key\", Yex.XmlTextPrelim.from([%{insert: \"Hello\"},%{insert: \" World\", attributes: %{ \"bold\" => true }},]))\n    iex> {:ok,%Yex.XmlText{} = text} = Yex.Map.fetch(map, \"key\")\n    iex> Yex.XmlText.to_delta(text)\n    [%{insert: \"Hello\"}, %{attributes: %{\"bold\" => true}, insert: \" World\"}]","ref":"Yex.XmlTextPrelim.html#from/1-examples-with-delta"},{"type":"type","title":"Yex.XmlTextPrelim.t/0","doc":"","ref":"Yex.XmlTextPrelim.html#t:t/0"},{"type":"exception","title":"Yex.DeletedSharedTypeError","doc":"","ref":"Yex.DeletedSharedTypeError.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}